using System.Diagnostics;
using Microsoft.Xna.Framework;
using Xfinity.AI.Entities.Managers;

namespace Xfinity.AI
{
    /// <summary>
    /// A Game Component which manages intelligent agents.
    /// </summary>
    public class AIManager : GlobalManager
    {
        private AgentCollection agents = new AgentCollection();
        /// <summary>
        /// The list of agents to update.
        /// </summary>
        public AgentCollection Agents
        {
            [DebuggerStepThrough]
            get { return agents; }
        }
        /// <summary>
        /// Constructs a new AI manager.
        /// </summary>
        /// <param name="name">The name of the manager.</param>
        /// <param name="game">The Game.</param>
        public AIManager(string name,Game game)
            : base(name,false,game)
        {
        }
    }
}
