using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Xfinity.Engine.GameStates
{
    public abstract class GameState : DrawableGameComponent
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GameState"/> class.
        /// </summary>
        public GameState():base(GameManager.Game)
        {

        }

        /// <summary>
        /// Initializes a new instance of the <see cref="GameState"/> class.
        /// </summary>
        /// <param name="game">The Game to add the component to.</param>
        public GameState(Game game):base(game)
        {

        }
        public abstract override void Update(GameTime gameTime);
        public abstract override void Draw(GameTime gameTime);
    }
}
