namespace Xfinity.Engine
{
    public struct Triplet<T>
    {
        private T first;

        /// <summary>
        /// Gets or sets the first item.
        /// </summary>
        /// <value>The first item.</value>
        public T First
        {
            get { return first; }
            set { first = value; }
        }
        private T second;

        /// <summary>
        /// Gets or sets the second item.
        /// </summary>
        /// <value>The second item.</value>
        public T Second
        {
            get { return second; }
            set { second = value; }
        }
        private T third;

        /// <summary>
        /// Gets or sets the third item.
        /// </summary>
        /// <value>The third item.</value>
        public T Third
        {
            get { return third; }
            set { third = value; }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="Triplet&lt;T&gt;"/> class.
        /// </summary>
        /// <param name="item">The item.</param>
        public Triplet(T item)
        {
            first = second = third = item;
        }
        /// <summary>
        /// Initializes a new instance of the <see cref="Triplet&lt;T&gt;"/> class.
        /// </summary>
        /// <param name="first">The first item.</param>
        /// <param name="second">The second item.</param>
        /// <param name="third">The third item.</param>
        public Triplet(T first, T second, T third)
        {
            this.first = first;
            this.second = second;
            this.third = third;
        }
    }
}
