using System.Collections.Generic;
using System.Diagnostics;
using Microsoft.Xna.Framework;

namespace Xfinity.Player
{
    /// <summary>
    /// The player.
    /// </summary>
    public partial class Player
    {
        static Vector3 forcedVelocity = Vector3.Zero;
        static Vector3 gravitationalVelocity = Vector3.Zero;
        private static List<Vector3> actingForces = new List<Vector3>();

        /// <summary>
        /// Gets the external forces acting on the player.
        /// </summary>
        /// <value>The acting forces.</value>
        public static List<Vector3> ActingForces
        {
            [DebuggerStepThrough]
            get { return actingForces; }
        }

        static float seconds;
        /// <summary>
        /// Calculates the forced velocity.
        /// </summary>
        protected void CalculateForcedVelocity()
        {
            
            foreach (Vector3 force in actingForces)
            {
                forcedVelocity += force * seconds;
            }
            System.Diagnostics.Debug.WriteLine(forcedVelocity, "Forces acting upon player at time "+ gt.TotalGameTime.ToString());
            
        }
        /// <summary>
        /// Calculates the gravitational velocity.
        /// </summary>
        protected void CalculateGravitationalVelocity()
        {
            
        }
    }
}
