﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Xfinity.Engine.Plugins;
using Xfinity.Engine;
namespace XfinityTests
{
    /// <summary>
    ///This is a test class for Xfinity.Engine.Plugins.Camera and is intended
    ///to contain all Xfinity.Engine.Plugins.Camera Unit Tests
    ///</summary>
    [TestClass()]
    public class CameraTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion
        [TestMethod]
        public void GeneralTest()
        {
            Camera camera = new Camera(Startup.game);
            camera.Initialize();
            camera.LookAt(Vector3.Right);
            camera.RotateYaw((float)Math.PI);
            camera.RotateRoll(MathHelper.TwoPi);
            camera.RotatePitch((float)Math.PI);


        }

        /// <summary>
        ///A test for AspectRatio
        ///</summary>
        [TestMethod()]
        public void AspectRatioTest()
        {

            Camera target = new Camera("lol", Startup.game);
            target.Initialize();
            float val = 4 / 3; 
            target.AspectRatio = val;

            Assert.AreEqual(val, target.AspectRatio, "Xfinity.Engine.Plugins.Camera.AspectRatio was not set correctly.");

        }

        /// <summary>
        ///A test for Camera (Game)
        ///</summary>
        [TestMethod()]
        public void ConstructorTest()
        {
            Assert.IsNotNull(Startup.camera);
        }

        /// <summary>
        ///A test for Camera (string, Game)
        ///</summary>
        [TestMethod()]
        public void ConstructorTest1()
        {
            string name ="lawl";

            Game game = Startup.game;

            Camera target = new Camera(name, game);

            Assert.IsNotNull(target);
            Assert.IsNotNull(target.Name);
        }

        /// <summary>
        ///A test for FarPlane
        ///</summary>
        [TestMethod()]
        public void FarPlaneTest()
        {
            float val = 100;

            Startup.camera.FarPlane = val;


            Assert.AreEqual(val, Startup.camera.FarPlane, "Xfinity.Engine.Plugins.Camera.FarPlane was not set correctly.");
        }

        /// <summary>
        ///A test for Fov
        ///</summary>
        [TestMethod()]
        public void FovTest()
        {
            Game game = Startup.game;

            Camera target = new Camera("", game);
            target.Initialize();
            float val = .123f;

            target.Fov = val;


            Assert.AreEqual(val, target.Fov, "Xfinity.Engine.Plugins.Camera.Fov was not set correctly.");
        }

        /// <summary>
        ///A test for Frustrum
        ///</summary>
        [TestMethod()]
        public void FrustrumTest()
        {


            Camera target = new Camera(Startup.game);

            BoundingFrustum val = new BoundingFrustum(Startup.camera.ViewProjectionMatrix);

            target.Frustrum = val;


            Assert.AreEqual(val, target.Frustrum, "Xfinity.Engine.Plugins.Camera.Frustrum was not set correctly.");

        }

        /// <summary>
        ///A test for Initialize ()
        ///</summary>
        [TestMethod()]
        public void InitializeTest()
        {

            Assert.AreNotEqual(Startup.camera.Position , new Matrix());
        }

        /// <summary>
        ///A test for LookAt (Vector3)
        ///</summary>
        [TestMethod()]
        public void LookAtTest()
        {
            Vector3 point = new Vector3(.1f,234f,1); 

            Startup.camera.LookAt(point);

            Assert.AreEqual(point, Startup.camera.Target);
        }

        /// <summary>
        ///A test for MoveAndRotate (Vector3, Vector3)
        ///</summary>
        [TestMethod()]
        public void MoveAndRotateTest()
        {
            Vector3 positionOffset = Vector3.UnitX;

            Vector3 targetOffset = Vector3.UnitY;
            Vector3 originalPosition = Startup.camera.Position;
            Vector3 originalTarget = Startup.camera.Target;
            Startup.camera.MoveAndRotate(positionOffset, targetOffset);

            Assert.AreEqual(Startup.camera.Position, originalPosition + positionOffset);
            Assert.AreEqual(Startup.camera.Target, originalTarget + targetOffset);
        }

        /// <summary>
        ///A test for MoveAndRotateAbsolute (Vector3, Vector3)
        ///</summary>
        [TestMethod()]
        public void MoveAndRotateAbsoluteTest()
        {

            Vector3 position = Vector3.Down;

            Vector3 target = Vector3.UnitY;

            Startup.camera.MoveAndRotateAbsolute(position, target);

            Assert.AreEqual(Startup.camera.Position, position);
            Assert.AreEqual(Startup.camera.Target, target);
        }

        /// <summary>
        ///A test for NearPlane
        ///</summary>
        [TestMethod()]
        public void NearPlaneTest()
        {

            float val = 1;

            Startup.camera.NearPlane = val;


            Assert.AreEqual(val, Startup.camera.NearPlane, "Xfinity.Engine.Plugins.Camera.NearPlane was not set correctly.");
        }

        /// <summary>
        ///A test for Position
        ///</summary>
        [TestMethod()]
        public void PositionTest()
        {

            Vector3 val = new Vector3(1, 2, 3);

            Startup.camera.Position = val;


            Assert.AreEqual(val, Startup.camera.Position, "Xfinity.Engine.Plugins.Camera.Position was not set correctly.");

        }

        /// <summary>
        ///A test for Projection
        ///</summary>
        [TestMethod()]
        public void ProjectionTest()
        {
            Matrix val = Matrix.CreatePerspectiveOffCenter(1, 2, 1, 2, 1, 2);

           Startup.camera.Projection = val;


           Assert.AreEqual(val, Startup.camera.Projection, "Xfinity.Engine.Plugins.Camera.Projection was not set correctly.");
        }

        /// <summary>
        ///A test for RotatePitch (float)
        ///</summary>
        [TestMethod()]
        public void RotatePitchTest()
        {
            float angle = .1f;
            Startup.camera.TargetDirection = Vector3.UnitX;
            Startup.camera.RotatePitch(angle);
            Vector3 r = Startup.camera.TargetDirection;
            Startup.camera.RotateYaw((float)Math.PI);
            Startup.camera.RotatePitch(-.2f);
            Assert.IsTrue(Math.Abs(Startup.camera.TargetDirection.X+r.X)< GraphicsHelper.Epsilon);
            Assert.IsTrue(Math.Abs(Startup.camera.TargetDirection.Y + r.Y) < GraphicsHelper.Epsilon);
            Assert.IsTrue(Math.Abs(Startup.camera.TargetDirection.Z + r.Z) < GraphicsHelper.Epsilon);
        }

        /// <summary>
        ///A test for Target
        ///</summary>
        [TestMethod()]
        public void TargetTest()
        {
            Vector3 val = Vector3.Left;

            Startup.camera.Target = val;

            Assert.AreEqual(val, Startup.camera.Target, "Xfinity.Engine.Plugins.Camera.Target was not set correctly.");
        }

        /// <summary>
        ///A test for TargetDirection
        ///</summary>
        [TestMethod()]
        public void TargetDirectionTest()
        {
            Game game = Startup.game;


            Vector3 val = Vector3.One;

            Startup.camera.TargetDirection = val;
            val.Normalize();

            Assert.AreEqual(val, Startup.camera.TargetDirection, "Xfinity.Engine.Plugins.Camera.TargetDirection was not set correctly.");
        }

        /// <summary>
        ///A test for Up
        ///</summary>
        [TestMethod()]
        public void UpTest()
        {


            Vector3 val = Vector3.Down;

            Startup.camera.Up = val;


            Assert.AreEqual(val, Startup.camera.Up, "Xfinity.Engine.Plugins.Camera.Up was not set correctly.");
        }

        /// <summary>
        ///A test for ViewMatrix
        ///</summary>
        [TestMethod()]
        public void ViewMatrixTest()
        {
            Matrix val = Matrix.CreateLookAt(Vector3.Zero, Vector3.One, Vector3.Up);

            Startup.camera.ViewMatrix = val;


            Assert.AreEqual(val, Startup.camera.ViewMatrix, "Xfinity.Engine.Plugins.Camera.ViewMatrix was not set correctly.");
        }

        /// <summary>
        ///A test for ViewProjectionMatrix
        ///</summary>
        [TestMethod()]
        public void ViewProjectionMatrixTest()
        {


            Matrix val = Matrix.Multiply(Matrix.CreateLookAt(Vector3.Left, Vector3.Right, Vector3.Up), Matrix.CreatePerspectiveFieldOfView(.45f, 4 / 3, 1, 10));

            Startup.camera.ViewProjectionMatrix = val;


            Assert.AreEqual(val, Startup.camera.ViewProjectionMatrix, "Xfinity.Engine.Plugins.Camera.ViewProjectionMatrix was not set correctly.");
        }

        /// <summary>
        ///A test for Zoom (float)
        ///</summary>
        [TestMethod()]
        public void ZoomTest()
        {

            float fieldOfView = .5f;
           
            Startup.camera.Zoom(fieldOfView);
            Assert.AreEqual(fieldOfView, Startup.camera.Fov);
            
        }

    }
}
