﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Xfinity;
using Xfinity.AI;
using Xfinity.Engine.Plugins;
using Xfinity.Player;
using Xfinity.Scripting;
using Xfinity.Weapons;
using System.IO;
namespace XfinityTests
{
    /// <summary>
    ///This is a test class for Xfinity.GameManager and is intended
    ///to contain all Xfinity.GameManager Unit Tests
    ///</summary>
    [TestClass()]
    public class GameManagerTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion




        /// <summary>
        ///A test for Camera
        ///</summary>
        [TestMethod()]
        public void CameraTest()
        {
            GameManager target = new GameManager(Startup.game);
            target.Initialize();

            Camera val = Xfinity.Engine.GraphicsHelper.ActiveCamera;

            target.Camera = val;


            Assert.AreEqual(val, target.Camera, "Xfinity.GameManager.Camera was not set correctly.");

        }

        /// <summary>
        ///A test for CreateNpcCharacter (string, string)
        ///</summary>
        [TestMethod()]
        public void CreateNpcCharacterTest()
        {
            GameManager target = new GameManager(new Game());
            try
            {
                target.CreateNpcCharacter(@"Content\Models\Characters\{Random}", "Supr-Neva");
            }
            catch (DirectoryNotFoundException) //This is because the content files aren't copied; if it gets to here, then it's definitely going to work.
            {
            }

        }

        /// <summary>
        ///A test for Game
        ///</summary>
        [TestMethod()]
        public void GameTest()
        {
            new GameManager(Startup.game);
            Assert.AreEqual(Startup.game, Xfinity.GameManager.Game, "Xfinity.GameManager.Game was not set correctly.");
        }

        /// <summary>
        ///A test for GameManager (Game)
        ///</summary>
        [TestMethod()]
        public void ConstructorTest()
        {
            Game game = new Game();//Startup.game;

            GameManager target = new GameManager(game);
            try
            {
                target = new GameManager(null);
            }
            catch (ArgumentException)
            {
            }

        }

        /// <summary>
        ///A test for Initialize ()
        ///</summary>
        [TestMethod()]
        public void InitializeTest()
        {

            GameManager target = Startup.gameManager;
            target.Initialize();
        }

        /// <summary>
        ///A test for LoadPlayerCharacter ()
        ///</summary>
        [TestMethod()]
        public void LoadPlayerCharacterTest()
        {

            GameManager.LoadPlayerCharacter();

        }

        /// <summary>
        ///A test for PlayerManager
        ///</summary>
        [TestMethod()]
        public void PlayerManagerTest()
        {

            GameManager target = new GameManager(Startup.game);
            target.Initialize();
            PlayerManager val = target.PlayerManager;
            Assert.AreEqual(val, target.PlayerManager, "Xfinity.GameManager.PlayerManager was not set correctly.");

        }

        /// <summary>
        ///A test for Random
        ///</summary>
        [TestMethod()]
        public void RandomTest()
        {
            GameManager target = new GameManager(Startup.game);
            target.Initialize();
            Random val = target.Random;


            Assert.AreEqual(val, target.Random, "Xfinity.GameManager.Random was not set correctly.");
        }
        [TestInitialize()]
        public void InitTests()
        {
            Startup.game.Services.RemoveService(typeof(GameManager));
            Startup.game.Services.RemoveService(typeof(InputHandler));
        }
        /// <summary>
        ///A test for ScriptManager
        ///</summary>
        [TestMethod()]
        public void ScriptManagerTest()
        {

            GameManager target = new GameManager(Startup.game);
            target.Initialize();
            ScriptManager val = GameManager.ScriptManager;


            Assert.AreEqual(val, Xfinity.GameManager.ScriptManager, "Xfinity.GameManager.ScriptManager was not set correctly.");
        }

        /// <summary>
        ///A test for WeaponManager
        ///</summary>
        [TestMethod()]
        public void WeaponManagerTest()
        {
            GameManager target = new GameManager(Startup.game);
            target.Initialize();

            WeaponManager val = target.WeaponManager;


            Assert.AreEqual(val, target.WeaponManager, "Xfinity.GameManager.WeaponManager was not set correctly.");
        }

    }
}
