using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.Xna.Framework;
using Xfinity.Engine.Plugins;
using Xfinity.AI;
using Xfinity.AI.Entities;
using Xfinity;

namespace XfinityTests
{
    [TestClass]
    public class Startup
    {
        public static Game game;
        public static Camera camera;
        [AssemblyInitialize]
        public static void Initialise(TestContext context)
        {
            game = new Game();
            Entity.Created += new EventHandler(Entity_Created);
            IGraphicsDeviceManager m = new GraphicsDeviceManager(game);
            gameManager = new GameManager(game);
            m.CreateDevice();
            GameManager.Game = game;
            AIManager ai = new AIManager("", game);
            ai.Initialize();
            camera = new Camera("camera", game);
            camera.Initialize();
        }
        public static GameManager gameManager;
        static void Entity_Created(object sender, EventArgs e)
        {
            Assert.IsNotNull(sender);
            Assert.IsInstanceOfType(sender, typeof(Entity));
        }
    }
}