uniform extern float4x4 WVPMatrix :  WORLDVIEWPROJECTION;

uniform extern texture SpriteTexture;
struct PS_INPUT
{
    #ifdef XBOX
        float2 TexCoord : SPRITETEXCOORD;
    #else
        float2 TexCoord : TEXCOORD0;
    #endif
    
};
struct VS_Output
{
	float4 Position : POSITION0;
	float Size : PSIZE;
};
sampler Sampler = sampler_state
{
    Texture = <SpriteTexture>;
};                        
float4 PixelShader(PS_INPUT input) : COLOR0
{
    float2 texCoord;

    texCoord = input.TexCoord.xy;

    return tex2D(Sampler, texCoord);
}

VS_Output VertexShader(float4 pos : POSITION0)
{
	VS_Output output;
	output.Position = mul(pos,WVPMatrix);
	output.Size = 1/output.Position.z;
    return output;
}


technique PointSpriteTechnique
{
    pass P0
    {
        vertexShader = compile vs_2_0 VertexShader();
        pixelShader = compile ps_2_0 PixelShader();
    }
}