using System.Reflection;

namespace Xfinity.Engine
{
    /// <summary>
    /// An interface defining a mod.
    /// </summary>
    public interface IMod
    {
        /// <summary>
        /// The name of the mod.
        /// </summary>
        string Name
        {
            get;
        }
        /// <summary>
        /// The assembly with the mod code.
        /// </summary>
        Assembly PrimaryAssembly
        {
            get;
        }

        /// <summary>
        /// The mod type.
        /// </summary>
        ModType ModType
        {
            get;
        }
    }
}
