using System.Diagnostics;
using Microsoft.Xna.Framework;

namespace Xfinity.Entities
{
    public abstract class Character : PhysicalEntity
    {
        protected Character(string name, Game game)
            : base(name, game)
        {
            inventory = new Inventory(this, game);
        }

        private Inventory inventory;

        public Inventory Inventory
        {
            [DebuggerStepThrough]
            get { return inventory; }
        }
        private Vector3 movementSpeed = new Vector3(30,20,30);

        public Vector3 NormalNaturalVelocity
        {
            [DebuggerStepThrough]
            get { return movementSpeed; }
            [DebuggerStepThrough]
            set { movementSpeed = value; }
        }
        private Vector3 velocity = Vector3.Zero;

        /// <summary>
        /// 
        /// </summary>
        public Vector3 Velocity
        {
            [DebuggerStepThrough]
            get { return velocity; }
            [DebuggerStepThrough]
            set { velocity = value; }
        }


    }
}
