using System.Collections.Generic;
using Microsoft.Xna.Framework;
//using System.Collections.Generic.PowerCollections;

namespace Xfinity.Entities
{
    /// <summary>
    /// A characters' possessions
    /// </summary>
    public class Inventory:LogicalEntity
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Inventory"/> class.
        /// </summary>
        /// <param name="character">The character.</param>
        /// <param name="game">The game.</param>
        public Inventory(Character character, Game game):base("Inventory for: "+character.Name,game)
        {
           // items = new MultiDictionary<PhysicalEntityType, PhysicalEntity>(true);
            skills = new Dictionary<SkillType, float>();
            
        }
        /// <summary>
        /// Indicates whether GameComponent.Update should be called when Game.Update is called.
        /// </summary>
        /// <value></value>
        /// <returns>true if GameComponent.Update should be called; false otherwise.</returns>
        public new bool Enabled
        { get { return false; } }
        //private MultiDictionary<PhysicalEntityType,PhysicalEntity> items;

        //public MultiDictionary<PhysicalEntityType,PhysicalEntity> Items
        //{
        //    get { return items; }
        //}
        private Dictionary<SkillType,float> skills;

        /// <summary>
        /// Gets the skills.
        /// </summary>
        /// <value>The skills.</value>
        public Dictionary<SkillType,float> Skills
        {
            get { return skills; }
        }

    }
    /// <summary>
    /// A skill type.
    /// </summary>
    public enum SkillType
    {
        /// <summary>
        /// How accurate the character is.
        /// </summary>
        Accuracy,
        /// <summary>
        /// The character's physical stamina.
        /// </summary>
        Stamina,

    }
}
