using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Xfinity.Entities;

namespace Xfinity.Logic
{
    public class TriggerComponent : GameComponent
    {
        public TriggerComponent()
            : this(GameManager.Game)
        {

        }
        public TriggerComponent(Game game)
            : base(game)
        {

        }



        public override void Update(GameTime gameTime)
        {
            foreach (Character c in masterList)
            {
                //stuff here
            }
            base.Update(gameTime);
        }




        private List<Character> masterList = new List<Character>();

        /// <summary>
        /// Gets the master list of characters to notify.
        /// </summary>
        public List<Character> MasterList
        {
            get { return masterList; }
        }
    }

    public struct TriggerMessage
    {
        public Vector3 Position;
        public float Radius;
        public TriggerType Trigger;
    }
    public enum TriggerType
    {
        None = 0,
        Gunfire,
        Footsteps,
        ShotAt,
        Explosion,
    }
}