using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace Xfinity.Rendering.Lighting
{
    public class DirectionalLight:ILight
    {
        #region Direction
        private Vector3 direction;

        /// <summary>
        /// Direction.
        /// </summary>
        public Vector3 Direction
        {
            [System.Diagnostics.DebuggerStepThroughAttribute]
            get { return direction; }
            [System.Diagnostics.DebuggerStepThroughAttribute]
            set { direction = value; }
        }
        #endregion
        #region Colour
        private Vector3 colour;

        /// <summary>
        /// Colour.
        /// </summary>
        public Vector3 Colour
        {
            [System.Diagnostics.DebuggerStepThroughAttribute]
            get { return colour; }
            [System.Diagnostics.DebuggerStepThroughAttribute]
            set { colour = value; }
        }
        #endregion
        public DirectionalLight()
        {
            direction = Vector3.Up;
            colour = Vector3.One;
        }
        public DirectionalLight(Vector3 direction, Vector3 colour)
        {
            this.direction = direction;
            this.colour = colour;
        }

        #region ILight Members

        public Vector3 GetColourAtPoint(Vector3 point)
        {
            return colour;
        }

        #endregion
    }
}