#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace Xfinity.Rendering.Sas
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public class SasEffect : GameComponent
    {
        #region Effect
        private Effect effect;

        /// <summary>
        /// Effect.
        /// </summary>
        public Effect Effect
        {
            [System.Diagnostics.DebuggerStepThroughAttribute]
            get { return effect; }
        }
        #endregion
        private Dictionary<string, EffectParameter> parameters = new Dictionary<string, EffectParameter>();
        private ICamera camera;
        public SasEffect(Effect effect, Game game)
            : base(game)
        {
            this.effect = effect;
            camera = ((ICameraHolder)game.Services.GetService(typeof(ICameraHolder))).ActiveCamera;
        }
        public static implicit operator Effect(SasEffect sas)
        {
            return sas.effect;
        }

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            // TODO: Add your initialization code here

            base.Initialize();
        }


        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            
            base.Update(gameTime);
        }
    }
}


